<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon May 29 17:33:32 CEST 2017 -->
<title>Knapsack</title>
<meta name="date" content="2017-05-29">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
<script type="text/javascript" src="../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Knapsack";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Knapsack.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../knapsack/Item.html" title="class in knapsack"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../index.html?knapsack/Knapsack.html" target="_top">Frames</a></li>
<li><a href="Knapsack.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">knapsack</div>
<h2 title="Class Knapsack" class="title">Class Knapsack</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>knapsack.Knapsack</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">Knapsack</span>
extends java.lang.Object</pre>
<div class="block">Represents the Knapsack,
 which is described with a capacity, the current total weight
 and profit, a list of items (see class Items) and a
 strategy (see package knapsack.strategies) for creating a solution.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Robert</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#Knapsack--">Knapsack</a></span>()</code>
<div class="block">Default Constructor.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#Knapsack-knapsack.strategies.Strategy-int-">Knapsack</a></span>(<a href="../knapsack/strategies/Strategy.html" title="interface in knapsack.strategies">Strategy</a>&nbsp;strategy,
        int&nbsp;capacity)</code>
<div class="block">Overloaded Constructor.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#addItem-knapsack.Item-">addItem</a></span>(<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&nbsp;item)</code>
<div class="block">Adds an item to the knapsack, if there is still enough capacity.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#addItems-javafx.collections.ObservableList-">addItems</a></span>(<a href="http://docs.oracle.com/javase/8/javafx/api/javafx/collections/ObservableList.html?is-external=true" title="class or interface in javafx.collections">ObservableList</a>&lt;<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&gt;&nbsp;items)</code>
<div class="block">Adds a list of item to the knapsack.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#getCapacity--">getCapacity</a></span>()</code>
<div class="block">Get the current value of the capacity property.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#getCurrentProfit--">getCurrentProfit</a></span>()</code>
<div class="block">Get the current value of the currentKnapsackProfit property.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#getCurrentWeight--">getCurrentWeight</a></span>()</code>
<div class="block">Get the current value of the currenKnapsacktWeight property.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/8/javafx/api/javafx/collections/ObservableList.html?is-external=true" title="class or interface in javafx.collections">ObservableList</a>&lt;<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#getItemsList--">getItemsList</a></span>()</code>
<div class="block">Get the current list of all available items for the knapsack to work with.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/8/javafx/api/javafx/collections/ObservableList.html?is-external=true" title="class or interface in javafx.collections">ObservableList</a>&lt;<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#getPackedInItems--">getPackedInItems</a></span>()</code>
<div class="block">Get the current list of items which are packed in.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="../knapsack/strategies/Strategy.html" title="interface in knapsack.strategies">Strategy</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#getStrategy--">getStrategy</a></span>()</code>
<div class="block">Get the current value of the strategy property.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#resetKnapsack--">resetKnapsack</a></span>()</code>
<div class="block">Reset the knapsack.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#setCapacity-int-">setCapacity</a></span>(int&nbsp;capacity)</code>
<div class="block">Sets the value of the capacity property.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#setStrategy-knapsack.strategies.Strategy-">setStrategy</a></span>(<a href="../knapsack/strategies/Strategy.html" title="interface in knapsack.strategies">Strategy</a>&nbsp;strategy)</code>
<div class="block">Sets the value of the strategy property.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../knapsack/Knapsack.html#solve--">solve</a></span>()</code>
<div class="block">Trying to create a solution with the current selected strategy.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Knapsack--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Knapsack</h4>
<pre>public&nbsp;Knapsack()</pre>
<div class="block">Default Constructor.
 Initializes a knapsack with chosen default values.</div>
</li>
</ul>
<a name="Knapsack-knapsack.strategies.Strategy-int-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Knapsack</h4>
<pre>public&nbsp;Knapsack(<a href="../knapsack/strategies/Strategy.html" title="interface in knapsack.strategies">Strategy</a>&nbsp;strategy,
                int&nbsp;capacity)</pre>
<div class="block">Overloaded Constructor.
 Initializes a knapsack with default values and chosen parameters.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>strategy</code> - the strategy for creating a solution.</dd>
<dd><code>capacity</code> - the capacity of the knapsack.</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getCapacity--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCapacity</h4>
<pre>public&nbsp;int&nbsp;getCapacity()</pre>
<div class="block">Get the current value of the capacity property.
 The capacity specifies the amount of space/capacity the knapsack has in total.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current knapsack capacity.</dd>
</dl>
</li>
</ul>
<a name="getCurrentWeight--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCurrentWeight</h4>
<pre>public&nbsp;int&nbsp;getCurrentWeight()</pre>
<div class="block">Get the current value of the currenKnapsacktWeight property.
 The weight should be greater than zero.
 The knapsack weight specifies the total weight of all items which are currently contained in the knapsack.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the total weight of all contained items.</dd>
</dl>
</li>
</ul>
<a name="getCurrentProfit--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCurrentProfit</h4>
<pre>public&nbsp;int&nbsp;getCurrentProfit()</pre>
<div class="block">Get the current value of the currentKnapsackProfit property.
 The Knapsack profit specifies the total profit of all items which are currently contained in the knapsack.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the total profit of all contained items.</dd>
</dl>
</li>
</ul>
<a name="getStrategy--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getStrategy</h4>
<pre>public&nbsp;<a href="../knapsack/strategies/Strategy.html" title="interface in knapsack.strategies">Strategy</a>&nbsp;getStrategy()</pre>
<div class="block">Get the current value of the strategy property.
 The strategy specifies which algorithm is used to create a solution.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the current strategy of knapsack.</dd>
</dl>
</li>
</ul>
<a name="setCapacity-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setCapacity</h4>
<pre>public&nbsp;void&nbsp;setCapacity(int&nbsp;capacity)</pre>
<div class="block">Sets the value of the capacity property.
 The capacity specifies the amount of space/capacity the knapsack has in total.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>capacity</code> - the capacity which the knapsack should have.</dd>
</dl>
</li>
</ul>
<a name="setStrategy-knapsack.strategies.Strategy-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setStrategy</h4>
<pre>public&nbsp;void&nbsp;setStrategy(<a href="../knapsack/strategies/Strategy.html" title="interface in knapsack.strategies">Strategy</a>&nbsp;strategy)</pre>
<div class="block">Sets the value of the strategy property.
 The strategy specifies which algorithm is used to create a solution.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>strategy</code> - the strategy/algorithm we want to use.</dd>
</dl>
</li>
</ul>
<a name="addItem-knapsack.Item-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addItem</h4>
<pre>public&nbsp;boolean&nbsp;addItem(<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&nbsp;item)</pre>
<div class="block">Adds an item to the knapsack, if there is still enough capacity.
 If successful, knapsack weight and profit will be adapted.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>item</code> - the item which we want to try to add to the solution.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>True, if the item could be added. Otherwise return false.</dd>
</dl>
</li>
</ul>
<a name="addItems-javafx.collections.ObservableList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addItems</h4>
<pre>public&nbsp;void&nbsp;addItems(<a href="http://docs.oracle.com/javase/8/javafx/api/javafx/collections/ObservableList.html?is-external=true" title="class or interface in javafx.collections">ObservableList</a>&lt;<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&gt;&nbsp;items)</pre>
<div class="block">Adds a list of item to the knapsack.
 See <a href="../knapsack/Knapsack.html#addItem-knapsack.Item-"><code>addItem(Item)</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>items</code> - list of items which we want to add.</dd>
</dl>
</li>
</ul>
<a name="getItemsList--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getItemsList</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/8/javafx/api/javafx/collections/ObservableList.html?is-external=true" title="class or interface in javafx.collections">ObservableList</a>&lt;<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&gt;&nbsp;getItemsList()</pre>
<div class="block">Get the current list of all available items for the knapsack to work with.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>list of all available items.</dd>
</dl>
</li>
</ul>
<a name="getPackedInItems--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPackedInItems</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/8/javafx/api/javafx/collections/ObservableList.html?is-external=true" title="class or interface in javafx.collections">ObservableList</a>&lt;<a href="../knapsack/Item.html" title="class in knapsack">Item</a>&gt;&nbsp;getPackedInItems()</pre>
<div class="block">Get the current list of items which are packed in.
 This list of items represents a solution and is depending on the strategy.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>list of items representing a solution.</dd>
</dl>
</li>
</ul>
<a name="solve--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>solve</h4>
<pre>public&nbsp;void&nbsp;solve()</pre>
<div class="block">Trying to create a solution with the current selected strategy.</div>
</li>
</ul>
<a name="resetKnapsack--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>resetKnapsack</h4>
<pre>public&nbsp;void&nbsp;resetKnapsack()</pre>
<div class="block">Reset the knapsack.
 The set of items will be emptied and the current weight and profit will be set to zero.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Knapsack.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../knapsack/Item.html" title="class in knapsack"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../index.html?knapsack/Knapsack.html" target="_top">Frames</a></li>
<li><a href="Knapsack.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
